!FILE       :	main.f90
!UNIT NAME  :	main	(PROGRAM)
!DESCRIPTION:	This program converts outputs (*.node & *.ele) from Triangle mesher (by Jonathan Shewchuk)
!				into a format readable by 2deuns.
!				In a near future I will use also *.edge files from Triangle mesher, so it won't be neccesary
!				to use the edge reconstruction routine within 2deuns, this subroutine is not very efficient
!				so I prefer to have the whole data from Triangle mesher. The only thing to do within 2deuns
!				will be the computation of the normals, which is not a difficult task.  
!				Feel free to use any mesher you like, I highly recommend Triangle, 
!				but the choice is up to the userthis subroutine computes the cell cfl number
!WRITTEN BY	:	Joel GUERRERO 
!REVISION	:	REV01-03/2007
!Email		:	joegi.geo@yahoo.com
program main

implicit none



!****************************************************************************************
!LOCAL VARIABLES DEFINITION
!
integer::nver,nele,i,c1,c2,c3,empty,flag

real::x,y

real,allocatable,dimension(:,:)::coor
integer,allocatable,dimension(:,:)::connec
integer,allocatable,dimension(:)::marker
!
!ATTENTION: ALL DUMMY VARIABLES DECLARED AS LOCAL VARIABLES ARE TEMPORAL
!THEY ARE ONLY USED WITHIN THE SUBROUTINE         
!****************************************************************************************


empty=0


!****************************************************************************************
!OPEN AND READ *.node FILE
!you need to change the name
!
open   (60,file="input.node",status='old',action='read')
rewind (60)

read(60,*) nver

allocate(coor(2,nver))
allocate(marker(nver))

do i=1,nver

	read(60,*) empty,x,y,flag
	coor(1,i)=x
	coor(2,i)=y
	marker(i)=flag

enddo

close(60)
!****************************************************************************************



!****************************************************************************************
!OPEN AND READ *.ele FILE
!you need to change the name
!
open   (60,file="input.ele",status='old',action='read')
rewind (60)

read(60,*) nele

allocate(connec(3,nele))

do i=1,nele

	read(60,*) empty,c1,c2,c3
	connec(1,i)=c1
	connec(2,i)=c2
	connec(3,i)=c3

enddo

close(60)
!****************************************************************************************



!****************************************************************************************
!DUMP DATA T outut.txt WHICH IS THE FORMAT TO USE IN 2DEUNS
!you need to change the name
!
open   (65,file="output.txt",status='unknown')
write(65,*) nver,nele
do i=1,nver
	write(65,*)i,coor(1,i),coor(2,i),marker(i)
enddo
do i=1,nele
	write(65,*)i,connec(1,i),connec(2,i),connec(3,i),0
enddo
close(65)
!****************************************************************************************



end program main
